<!DOCTYPE html>
<html lang="en">

<head>
    <title>List Order</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<script>
    "use strict";
    $(document).ready(function () {
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        var gId;
        var gOrderCode;

        const gPizzaType = ["S", "M", "L"]
        const gORDER = ["orderCode", "kichCo", "loaiPizza", "idLoaiNuocUong", "thanhTien", "hoTen", "soDienThoai", "trangThai", "action"];
        const gCOLUMN_ORDER_CODE = 0;
        const gCOLUMN_KICH_CO = 1;
        const gCOLUMN_LOAI_PIZZA = 2;
        const gCOLUMN_ID_LOAI_NUOC_DUNG = 3;
        const gCOLUMN_THANH_TIEN = 4;
        const gCOLUMN_HO_TEN = 5;
        const gCOLUMN_SO_DIEN_THOAI = 6;
        const gCOLUMN_TRANG_THAI = 7;
        const gCOLUMN_ACTION = 8;
        //định nghĩa table - chưa có data
        var gDataTable = $("#table-order").DataTable({
            "columns": [
                { "data": gORDER[gCOLUMN_ORDER_CODE] },
                { "data": gORDER[gCOLUMN_KICH_CO] },
                { "data": gORDER[gCOLUMN_LOAI_PIZZA] },
                { "data": gORDER[gCOLUMN_ID_LOAI_NUOC_DUNG] },
                { "data": gORDER[gCOLUMN_THANH_TIEN] },
                { "data": gORDER[gCOLUMN_HO_TEN] },
                { "data": gORDER[gCOLUMN_SO_DIEN_THOAI] },
                { "data": gORDER[gCOLUMN_TRANG_THAI] },
                { "data": gORDER[gCOLUMN_ACTION] }
            ],
            //ghi đè nội dung cột action, chuyển thành button Chi tiết
            "columnDefs": [
                {
                    "targets": gCOLUMN_ACTION,
                    "defaultContent": "<button class='btn-detail btn btn-success'>Chi tiết</button>"
                }
            ]
        });
        /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */

        onPageLoading()
        // load data select Drink trên modal
        getDrinkList()
        // load data select Loại Pizza trên modal    
        getPizzaType()
        // gán sự kiện cho nút chi tiết
        $("#table-order").on('click', ".btn-detail", function () {
            onBtnChiTietClick(this);
        });
        // gán sự kiện cho nút Confirm trên modal
        $("#btn-confirm").on('click', function () {
            onBtnConfirmClick();
        })
        // gán sự kiện cho nút Confirm trên modal
        $("#btn-cancel").on('click', function () {
            onBtnCancelClick();
        })

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        function onPageLoading() {
            getAllOrder()
        }

        // hàm khi nút chi tiết được ấn hiển thị thông tin lên modal
        function onBtnChiTietClick(paramButton) {
            var vRow = $(paramButton).closest("tr")
            var vDataRow = gDataTable.row(vRow).data()
            gId =  vDataRow.id // lưu id vào biến toàn cục 
            gOrderCode = vDataRow.orderCode 
            // hàm call API lấy thông tin chi tiết order bu ORDER CODE
            getOrderByOrderCode(gOrderCode)
        }

        // hàm load dữ liệu select Drink trên modal
        function getDrinkList() {
            $.ajax({
                url: "http://203.171.20.210:8080/devcamp-pizza365/drinks",
                type: "GET",
                success: function (paramDrinks) {
                    handleDrinkList(paramDrinks);
                },
                error: function (ajaxContext) {
                    alert(ajaxContext.responseText);
                }
            });
        }
        // hàm nut confirm trên modal
        function onBtnConfirmClick() {
            var vConfirm = {
                trangThai: "confirmed"
            }

            callUpdateOrder(vConfirm)
        }
        // hàm nut cancel trên modal
        function onBtnCancelClick() {
            var vCancel = {
                trangThai: "cancel"
            }

            callUpdateOrder(vCancel)
        }

        // /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        // hàm call API lấy thông tin order by ORDER CODE
        function getOrderByOrderCode(paramOrderCode) {
            $.ajax({
                url: "http://203.171.20.210:8080/devcamp-pizza365/orders/" + paramOrderCode,
                type: "GET",
                success: function (paramOjb) {
                    handleOrderDetail(paramOjb);
                },
                error: function (paramErr) {
                    console.log(paramErr.status)
                }
            })
        }
        // hàm call API Updtate order
        function callUpdateOrder(paramOjb) {
            $.ajax({
                url: "http://203.171.20.210:8080/devcamp-pizza365/orders/" + gId,
                type: 'PUT',
                contentType: 'application/json',
                data: JSON.stringify(paramOjb), //chuyển obj thành json string
                success: function (responseObj) {
                    $("#order-modal").modal("hide"); // ản modal đi
                    getAllOrder() // load lại bảng
                    

                },
                error: function (ajaxContext) {
                    alert(ajaxContext.responseText);
                }
            });

        }
        // call API all Order
        function getAllOrder(){
            $.ajax({
                url: "http://203.171.20.210:8080/devcamp-pizza365/orders",
                type: "GET",
                success: function (paramRes) {
                    loadDataToTable(paramRes)
                },
                error: function (paramErr) {
                    console.log(paramErr.status)
                }
            })
        }
        function handleDrinkList(paramDrinks) {
            $.each(paramDrinks, function (i, item) {
                $("<option>", {
                    text: item.tenNuocUong,
                    value: item.maNuocUong
                }).appendTo($("#select-drink"))
            })
        }

        // hàm load dữ liệu lên select SIZE Pizza Trên modal
        function getPizzaType() {
            $.each(gPizzaType, function (i, item) {
                $("<option>", {
                    text: item,
                    value: item.toLowerCase()
                }).appendTo($("#select-pizzasize"));
            });
        }
        // hàm hiển thị thông tin lên modal
        function handleOrderDetail(paramOjb) {
            $("#order-modal").modal("show") // Show modal

            $("#inp-ordercode").val(paramOjb.orderCode);
            $("#select-pizzasize").val(paramOjb.kichCo.toLowerCase());
            $("#inp-duongkinh").val(paramOjb.duongKinh);
            $("#inp-suon").val(paramOjb.suon);
            $("#inp-salad").val(paramOjb.salad);
            $("#inp-pizzatype").val(paramOjb.loaiPizza);
            $("#inp-idvoucher").val(paramOjb.idVourcher);
            $("#inp-thanhtien").val(paramOjb.thanhTien);
            $("#inp-giamgia").val(paramOjb.giamGia);
            $("#select-drink").val(paramOjb.idLoaiNuocUong);
            $("#inp-soluongdrink").val(paramOjb.soLuongNuoc);
            $("#inp-hoten").val(paramOjb.hoTen);
            $("#inp-email").val(paramOjb.email);
            $("#inp-phone").val(paramOjb.soDienThoai);
            $("#inp-address").val(paramOjb.diaChi);
            $("#inp-message").val(paramOjb.loiNhan);
            $("#inp-orderday").val(paramOjb.ngayTao);
            $("#inp-updatedate").val(paramOjb.ngayCapNhat);
        }

        // // hàm load DATA lên bảng
        function loadDataToTable(paramOrder) {
            gDataTable.clear()
            gDataTable.rows.add(paramOrder)
            gDataTable.draw()
        }


    });
</script>

<body>
    <div class="container-fluid mt-2">
        <h2 class="text-center">Danh sách đơn hàng</h2>
    </div>
    <div class="container-fluid">
        <table class="table table-bordered table-striped table-hover" id="table-order">
            <thead class="thead-dark">
                <tr>
                    <th>Order Code</th>
                    <th>Kích cỡ Combo</th>
                    <th>Loại Pizza</th>
                    <th>Nước uống</th>
                    <th>Thành tiền</th>
                    <th>Họ và tên</th>
                    <th>Số điện thoại</th>
                    <th>Trạng thái</th>
                    <th>Action</th>

                </tr>
            </thead>
        </table>
    </div>
    <!-- Modal order info -->
    <div id="order-modal" class="modal fade text-center" tabindex="-1">
        <div class="modal-dialog modal-lg">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Order Detail!</h5>
                    <button type="button" class="close" data-dismiss="modal">&times;</button>
                </div>
                <!-- Modal body -->
                <div class="modal-body">
                    <div class="form-group row">
                        <div class="col-md-2">
                            <label for="">Order Code</label>
                        </div>
                        <div class="col-md-10">
                            <input id="inp-ordercode" class="form-control" type="text">
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-md-2">
                            <label for="">Pizza Size</label>
                        </div>
                        <div class="col-md-10">
                            <select id="select-pizzasize" class="form-control"></select>
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-md-2">
                            <label for="">Đường kính</label>
                        </div>
                        <div class="col-md-10">
                            <input id="inp-duongkinh" class="form-control" type="text">
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-md-2">
                            <label for="">Sườn</label>
                        </div>
                        <div class="col-md-10">
                            <input id="inp-suon" class="form-control" type="text">
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-md-2">
                            <label for="">Salad</label>
                        </div>
                        <div class="col-md-10">
                            <input id="inp-salad" class="form-control" type="text">
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-md-2">
                            <label for="">Pizza Type</label>
                        </div>
                        <div class="col-md-10">
                            <input id="inp-pizzatype" class="form-control" type="text">
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-md-2">
                            <label for="">ID Voucher</label>
                        </div>
                        <div class="col-md-10">
                            <input id="inp-idvoucher" class="form-control" type="text">
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-md-2">
                            <label for="">Thành tiền</label>
                        </div>
                        <div class="col-md-10">
                            <input id="inp-thanhtien" class="form-control" type="text">
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-md-2">
                            <label for="">Giảm giá</label>
                        </div>
                        <div class="col-md-10">
                            <input id="inp-giamgia" class="form-control" type="text">
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-md-2">
                            <label for="">Loại đồ uống</label>
                        </div>
                        <div class="col-md-10">
                            <select id="select-drink" class="form-control">
                                <option value="0">Loại đồ uống</option>
                            </select>
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-md-2">
                            <label for="">Số lượng nước uống</label>
                        </div>
                        <div class="col-md-10">
                            <input id="inp-soluongdrink" class="form-control" type="text">
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-md-2">
                            <label for="">Họ và tên</label>
                        </div>
                        <div class="col-md-10">
                            <input id="inp-hoten" class="form-control" type="text">
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-md-2">
                            <label for="">Email</label>
                        </div>
                        <div class="col-md-10">
                            <input id="inp-email" class="form-control" type="text">
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-md-2">
                            <label for="">Số điện thoại</label>
                        </div>
                        <div class="col-md-10">
                            <input id="inp-phone" class="form-control" type="text">
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-md-2">
                            <label for="">Địa chỉ</label>
                        </div>
                        <div class="col-md-10">
                            <input id="inp-address" class="form-control" type="text">
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-md-2">
                            <label for="">Lời nhắn</label>
                        </div>
                        <div class="col-md-10">
                            <input id="inp-message" class="form-control" type="text">
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-md-2">
                            <label for="">Ngày order</label>
                        </div>
                        <div class="col-md-10">
                            <input id="inp-orderday" class="form-control" type="text">
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-md-2">
                            <label for="">Ngày chỉnh sửa</label>
                        </div>
                        <div class="col-md-10">
                            <input id="inp-updatedate" class="form-control" type="text">
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-sm-6 form-group">
                            <button id="btn-confirm" class="btn btn-warning col-sm-12">Confirm</button>
                        </div>
                        <div class="col-sm-6 form-group">
                            <button id="btn-cancel" class="btn btn-danger col-sm-12">Cancel</button>
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    <button data-dismiss="modal" class="btn btn-secondary"> Close</button>
                </div>
            </div>
        </div>
    </div>
</body>

</html>